// OS X port (C) 2003 Eli Curtz <eli@nuprometheus.com>
// Original Linux version (C) 2003 Ulrich Hecht <uli@emulinks.de>
// Licensed under the terms of the GNU Public License version 2
// Portions of this file were based on the Apple USB EZLoader sample code

#define MAX_INTEL_HEX_RECORD_LENGTH 16
typedef struct _INTEL_HEX_RECORD
{
   UInt32  	Length;
   UInt32 	Address;
   UInt32  	Type;
   UInt8  	Data[MAX_INTEL_HEX_RECORD_LENGTH];
} INTEL_HEX_RECORD, *PINTEL_HEX_RECORD;

IOReturn EstablishCommunication();
void CleanupCommunication();

IOReturn ConfigureAnchorDevice(IOUSBDeviceInterface **dev);

IOReturn AnchorWrite(IOUSBDeviceInterface **dev, UInt16 anchorAddress, UInt16 count, UInt8 writeBuffer[]);
FILE *openFile(UInt16 vendor, UInt16 product);

IOReturn hexRead(INTEL_HEX_RECORD *record, FILE *hexFile);

IOReturn DownloadToAnchorDevice(IOUSBDeviceInterface **dev, UInt16 vendor, UInt16 product);

      
void RawDeviceAdded(void *refCon, io_iterator_t iterator);
void RawDeviceRemoved(void *refCon, io_iterator_t iterator);
void NewDeviceAdded(void *refCon, io_iterator_t iterator);
void NewDeviceRemoved(void *refCon, io_iterator_t iterator);
